const app = getApp()
import {
	Base
} from '../../../utils/base.js';
const base = new Base()
Page({

	/**
	 * 页面的初始数据
	 */
	data: {
		coach_id: '',
		currentArea: [],

		city: '',
		cityShow: false,
		cityList: [],
		city_name: '',
		cityChecked: '',
		show: false,
		areaNameList: [],
	},

	/**
	 * 生命周期函数--监听页面加载
	 */
	onLoad: function (options) {
		this.setData({
			coach_id: app.globalData.coach_id
		})
		this.getMyarea()
		this.getCitylist()

	},
	getMyarea: function () {
		let params = {
			url: 'coach/myarea',
			data: {
				coach_id: this.data.coach_id,
			},
			callback: (data) => {
				var arr = []
				for (var i in data.area) {
					let option = {
						id: data.area[i] != null && data.area[i].id ? data.area[i].id : '',
						name: data.area[i] != null && data.area[i].name ? data.area[i].name : '',
					}
					arr.push(option)
				}
				this.setData({
					currentArea: arr,
					cityChecked: data.city != null && data.city.city_name != '' ? data.city.city_name : '',
					city: data.city != null && data.city.city_name != '' ? data.city.city_name : '',
					region_id: data.city != null && data.city.region_id != '' ? data.city.region_id : '',
					city_id: data.city != null && data.city.city_id != '' ? data.city.id : '',
				})
				console.log(this.data.currentArea)
			}
		}
		base.newRequest(params)
	},
	getCitylist: function () {
		let params = {
			url: 'coach/city',
			callback: (data) => {
				this.setData({
					cityList: data
				})
				if (this.data.city == '') {
					for (let i = 0; i < data.length; i++) {
						if (data[i].is_default == 1) {
							this.setData({
								cityChecked: data[i].city_name,
								city: data[i].city_name,
								region_id: data[i].region_id,
								city_id: data[i].id
							})
						}
					}
				}
				this.getArealist(this.data.region_id)
				
			}
		}
		base.newRequest(params)
	},
	getArealist: function (region_id) {
		let params = {
			url: 'coach/area',
			data: {
				region_id: region_id
			},
			callback: (data) => {
				var areaNameList = []
				for (let i in data) {
					areaNameList.push(data[i].name); //属性
				}
				this.setData({
					areaNameList: areaNameList,
					areaList: data
				})
			}
		}
		base.newRequest(params)
	},
	showCitypop(e) {
		this.setData({
			show: true,
			showIndex: e.currentTarget.dataset.index
		})
	},
	onClose() {
		this.setData({
			show: false
		})
	},


	changeCity: function (e) {
		this.setData({
			cityShow: true
		})
	},
	closeCityShow: function (e) {
		this.setData({
			cityShow: false
		})
	},

	chooseCity(e) {
		let city_name = e.currentTarget.dataset.item.city_name;
		let city_id = e.currentTarget.dataset.item.id;
		let region_id = e.currentTarget.dataset.item.region_id;
		if (e.currentTarget.dataset.item.city_name != this.data.cityChecked) {
			this.setData({
				cityChecked: city_name,
				cityChecked_id: city_id,
				region_id: region_id
			})
			this.getArealist(region_id)
		}
	},
	cityChangeComfirm: function (e) {
		const {
			cityChecked,
			cityChecked_id,
			region_id
		} = this.data;
		for(let i=0;i<this.data.currentArea.length;i++){
			this.data.currentArea[i].id = ''
			this.data.currentArea[i].name = ''
			
		}
		this.setData({
			city: cityChecked,
			city_id: cityChecked_id,
			cityShow: false,
			currentArea : this.data.currentArea

		})
		this.getArealist(region_id)
	},

	onConfirm(event) {
		let index = event.detail.index
		let list = this.data.currentArea
		list[this.data.showIndex - 1].name = this.data.areaList[index].name
		list[this.data.showIndex - 1].id = this.data.areaList[index].id
		this.setData({
			currentArea: list,
			show: !this.data.show
		})
	},
	onCancel() {
		this.setData({
			show: !this.data.show
		})
	},
	save: function () {
		if (this.data.currentArea[0].id || this.data.currentArea[1].id || this.data.currentArea[2].id) {
			let params = {
				url: 'coach/save_area',
				data: {
					coach_id: this.data.coach_id,
					city_id: this.data.city_id,
					first_area: this.data.currentArea[0].id,
					second_area: this.data.currentArea[1].id,
					third_area: this.data.currentArea[2].id
				},
				type: 'POST',
				callback: (data) => {
					base.toast('保存区域成功')
					base.goBack(2)
				}
			}
			base.newRequest(params)
		} else {
			base.toast('请至少选择一个意向区域')
		}
	},

})